local _, namespace = ...

local L = setmetatable({}, { __index = function(t, k)
	local v = tostring(k)
	rawset(t, k, v)
	return v
end })

namespace.L = L

local LOCALE = GetLocale()

if LOCALE == "enUS" then
	-- The EU English game client also
	-- uses the US English locale code.
	L["flask_link_alliance"] = "\124cff1eff00\124Hitem:166750::::::::120:::::\124h[Draught of Ten Lands]\124h\124r"
	L["flask_link_horde"] = "\124cff1eff00\124Hitem:166751::::::::120:::::\124h[Draught of Ten Lands]\124h\124r"
	L["addon_loaded"] = "The Addon was successfully loaded."
	L["flask_active"] = "The EP Flask %s is %d Minutes active."
	L["flask_not_active"] = "The EP Flask %s is not active."
	L["flask_detected"] = "The EP Flask was detected. 60 minutes remaining."
	L["flask_resetted"] = "The Timer for the flask was resetted."
return end

if LOCALE == "deDE" then
	-- German translations go here
	L["flask_link_alliance"] = "\124cff1eff00\124Hitem:166750::::::::120:::::\124h[Destillat der zehn Länder]\124h\124r"
	L["flask_link_horde"] = "\124cff1eff00\124Hitem:166751::::::::120:::::\124h[Destillat der zehn Länder]\124h\124r"
	L["addon_loaded"] = "Das Addon wurde erfolgreich geladen."
	L["flask_active"] = "Der EP Trank %s ist noch %d Minuten aktiv."
	L["flask_not_active"] = "Der EP Trank %s ist nicht aktiv."
	L["flask_detected"] = "Der EP Trank wurde entdeckt. 60 Minuten verbleibend."
	L["flask_resetted"] = "Die verbleibende Zeit für den Trank wurde zurückgesetzt."
return end