local EPFlaskTime, namespace = ...
local L = namespace.L
EPFlaskTime = LibStub("AceAddon-3.0"):NewAddon("EPFlaskTime", "AceEvent-3.0", "AceConsole-3.0")
local playerFaction, flaskFaction = 0, ""
local flaskIndex = 1 
local f1
local _G = _G
local DEBUG = 0

--Text Frame
f1 = CreateFrame("Frame",nil,_G["BuffButton"..flaskIndex])
f1:SetWidth(30) 
f1:SetHeight(30) 
f1:SetAlpha(.90);
f1:SetPoint("CENTER", _G["BuffButton"..flaskIndex], "TOP",0,0)
f1.text = f1:CreateFontString(nil,"ARTWORK") 
f1.text:SetFont("Fonts\\2002.ttf", 7, "OUTLINE")
f1.text:SetPoint("CENTER",0,0)
f1:Hide()

local function displayupdate(show, message)
    if show == 1 then
        f1.text:SetText(message)
		f1:SetPoint("CENTER", _G["BuffButton"..flaskIndex], "CENTER",0,-14)
        f1:Show()
    else
        f1:Hide()
    end
end

function round(val, decimal)
	if (decimal) then
		return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
	else
		return math.floor(val+0.5)
	end
end

function EPFlaskTime:OnInitialize()
	self:RegisterChatCommand("epinfo", "ConsoleComand")
	self:RegisterChatCommand("epreset", "EPResetCMD")
	print("[EPFlaskTime]: "..L["addon_loaded"])
end	

function EPFlaskTime:OnEnable()
	self:RegisterGossipEvents()
end

function EPFlaskTime:OnDisable()
  self:UnregisterAllEvents()
end

function EPFlaskTime:ConsoleComand(arg)
	local tempTime = EPTrankTime-time()
	if tempTime > 0 then
		print("[EPFlaskTime]: "..string.format(L["flask_active"], L["flask_link_"..flaskFaction], math.floor((tempTime/60))));
	else
		print("[EPFlaskTime]: "..string.format(L["flask_not_active"], L["flask_link_"..flaskFaction]));
	end
end

function EPFlaskTime:EPResetCMD(arg)
	resetFlaskTime();
	
	print("[EPFlaskTime]: "..L["flask_resetted"]);
end

function EPFlaskTime:RegisterGossipEvents()
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("PLAYER_LOGOUT")
end

function EPFlaskTime:ADDON_LOADED()
	if EPTrankTracked == nil then
		resetFlaskTime();
	end
end

function EPFlaskTime:PLAYER_ENTERING_WORLD()
	--get remaining time state
	local englishFaction, localizedFaction = UnitFactionGroup("player")
	
	if englishFaction == "Alliance" then
		playerFaction = 0
		flaskFaction = "alliance"
	else
		playerFaction = 1
		flaskFaction = "horde"
	end
	
	if LastKnownDiff == nil then
		LastKnownDiff = 0
		displayupdate(0, "0 m")
	else
		if EPLastLogout == true then
			if LastKnownDiff > 0 then
				EPTrankTime = time()+LastKnownDiff
				EPTrankTracked = 1
				
				if LastKnownDiff >= 60 then
					displayupdate(1, math.floor((LastKnownDiff/60)).." m")
				else
					displayupdate(1, math.floor(LastKnownDiff).." s")
				end
			else
				resetFlaskTime();
			end
			
			EPLastLogout = false
		end
	end
end

function EPFlaskTime:PLAYER_LOGOUT()
	--Save remaining time state
	local tempTime = EPTrankTime-time()
	if tempTime > 0 then
		LastKnownDiff = tempTime
		EPLastLogout = true
	else
		LastKnownDiff = 0
	end
end

function EPFlaskTime:UNIT_AURA()
	if EPTrankTracked == 0 then
		local y,n,t,s,_,spellID = 0,"",0,0,0
		local EPTrankCount = 0
		
		for i=1,BUFF_ACTUAL_DISPLAY do 
			local n,_,_,_,_,t,_,s,_,spellID=UnitAura("player",i) 
			if spellID ~= nil then
				--print(n.." (ID: "..spellID..") "..i.."!") 
				
				if spellID == 289982 then
					EPTrankTime = time()+3600
					EPTrankTracked = 1
					print("[EPFlaskTime]: "..L["flask_detected"])
					EPTrankCount = EPTrankCount+1
					flaskIndex = i
					
					EPTrankTimeOut = 0
					EPTrankTimeOutActive = 0
				end
			end
		end
		
		if EPTrankCount <= 0 then
			resetFlaskTime();
		end
	else
		--local posX, posY = GetPlayerMapPosition("player");
		--print("X: "..posX..", Y: "..posY)
	
		if UnitInVehicle("player") then
			displayupdate(0, "0 m")
		else
			--Get active buffs
			local EPTrankCount = 0
			for i=1,BUFF_ACTUAL_DISPLAY do 
				local n,_,_,_,_,t,_,s,_,spellID=UnitAura("player",i) 
				if spellID ~= nil then
					if spellID == 289982 then
						flaskIndex = i
						EPTrankCount = EPTrankCount+1
					end
				end
			end
			
			--Check if ep flask timeout active and reset time if longer than 2 minutes
			local EPTrankTimeOutDiff = time()-EPTrankTimeOut
			if EPTrankTimeOutActive == 1 then
				if DEBUG == 1 then
					print("[EP DEBUG]: Timeout active")
				end
				
				if EPTrankTimeOutDiff >= 180 then
					if DEBUG == 1 then
						print("[EP DEBUG]: Timeout >=180. Reset time")
					end
				
					EPTrankTimeOut = time()
				end
			end
			
			--check if ep flask active and set timeout for 60 sec to reset flask timer
			if EPTrankCount <= 0 then
				if DEBUG == 1 then
					print("[EP DEBUG]: No flask found")
				end
				
				if EPTrankTimeOutActive == 1 and EPTrankTimeOut ~= 0 then
					if DEBUG == 1 then
						print("[EP DEBUG]: Timeout active and greater than zero")
					end
					local timeOutDiff = time()-EPTrankTimeOut
					
					if timeOutDiff < 180 and timeOutDiff >= 120 then
						if DEBUG == 1 then
							print("[EP DEBUG]: Timeout in range ("..timeOutDiff..") reset buff")
						end
						
						resetFlaskTime();
					end
				else
					if DEBUG == 1 then
						print("[EP DEBUG]: Timeout not active. Set timeout")
					end
				
					EPTrankTimeOutActive = 1
					EPTrankTimeOut = time()
				end
			else
				if DEBUG == 1 then
					--print("[EP DEBUG]: Flask found delete timeout")
				end
				
				EPTrankTimeOutActive = 0
				EPTrankTimeOut = 0
			end
			
			--show remaining time on buff bar
			local tempTime = EPTrankTime-time()
			if tempTime > 0 then
				local tempTime = EPTrankTime-time()
				if tempTime >= 60 then
					displayupdate(1, math.floor((tempTime/60)).." m")
				else
					displayupdate(1, math.floor(tempTime).." s")
				end
			else
				resetFlaskTime();
			end
		end
	end
end

function resetFlaskTime()
	EPLastLogout = true
	EPTrankTracked = 0
	EPTrankTime = 0
	LastKnownDiff = 0
	displayupdate(0, "0 m")
	EPTrankTimeOut = 0
	EPTrankTimeOutActive = 0
end